<script>
export default {
  name: 'BaseText',
  props: {
    message: {
      type: String,
      default: ''
    },
    bold: {
      type: Boolean,
      default: false
    },
    caps: {
      type: Boolean
    },
    required: {
      type: Boolean
    },
    small: {
      type: Boolean,
      default: false
    },
    flat: {
      type: Boolean,
      default: false
    },
    icon: {
      type: String
    },
    size: {
      type: Number,
      default: 15
    },
    color: {
      type: String,
      default: '#FFFFFF'
    },
    gradient: {
      type: String,
      validator: function (value) {
        return ['light-grey','grey', 'orange'].indexOf(value) !== -1;
      }
    },
    align: {
      type: String,
      default: 'center',
      validator: function (value) {
        return ['left', 'center', 'right'].indexOf(value) !== -1;
      }
    }

  },
  computed: {
    classes() {
      // default classes
      let classes = ['base-text', 'base-text-align--' + this.align];

      if(this.bold) {
        // font-weight 900
        classes.push('base-text--bold');
      }

      // // adds asterisk to the field
      if(this.required && !this.small) {
        classes.push('required');
      }

      // no line-height and no padding
      if(this.flat) {
        classes.push('base-text--flat');
      }

      if(this.gradient) {
        classes.push('base-text--fit-content');
        classes.push('base-text_gradient--' + this.gradient);
      }

      return classes;
    }
  },

  render (createElement, context) {

    const icon = createElement(
      'BaseSvgIcon',
      {
        props: { icon: this.icon },
        style: { width: this.size, height: this.size }
      }
    )
    const h1 = createElement(
      'h1',
      {
        class: this.classes,
        style: {
          fontSize: this.size + 'px',
          padding: '5px',
          color: this.color,
        }
      },
      this.caps ? this.message.toUpperCase() : this.message,
      this.$slots.default
    );

    let elements = [h1];
    let customClasses = ['base-text'];

    // adds asterisk to the field
    if(this.required && this.small) {
      customClasses.push('base-text_required');
      customClasses.push('required');
    }

    if(this.icon) {
      // add the icon first
      elements.unshift(icon);
      // we need it centered if there are any icons present
      customClasses.push('base-text--centered');
    }

    return createElement(
      'div',
      {
        class: customClasses
      },
      elements
    );
  }
}
</script>

<style scoped>
.base-text {
  font-weight: 600;
  letter-spacing: 0px;
  color: #FFFFFF;

}

.base-text--bold {
  font-weight: 900;
}

.base-text--centered {
  display: flex;
  flex-direction: row;
  align-items: center;
}

.base-text-align--centered {
  text-align: center;
}

.base-text-align--left {
  text-align: left;
}

.base-text-align--right {
  text-align: right;
}

.base-text--flat {
  line-height: 0 !important;
  padding: 0 !important;
}

.base-text_gradient--light-grey {
  background: linear-gradient(260deg, #DEEDF0, #7986A3);
  -webkit-background-clip: text;
  -webkit-text-fill-color: transparent;
}


.base-text_gradient--grey {
  background: linear-gradient(256deg, #DAE9ED, #7A87A4);
  -webkit-background-clip: text;
  -webkit-text-fill-color: transparent;
}

.base-text_gradient--orange {
  background: linear-gradient(310deg, #FD8A6B, #E542C8);
  -webkit-background-clip: text;
  -webkit-text-fill-color: transparent;
}

.base-text--fit-content{
  width: fit-content;
}

.base-text_required {
  display: flex;
  flex-direction: row;
  align-items: center;
}

.required:after {
  content:" *";
  color: #FF578A;
}

</style>
